﻿package
{
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.net.URLRequest;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.filters.BlurFilter;

	public class StackItem extends Sprite
	{
		private var imageLoader:Loader;
		private var reflectionLoader:Loader;
		
		private var bmp:Bitmap = new Bitmap();
		private var bmpData:BitmapData = new BitmapData(380, 270, true, 0xff0000);
		
		private var reflectionBmp:Bitmap = new Bitmap();
		private var reflectionBmpData:BitmapData = new BitmapData(380, 270, true, 0xff0000);
		
		
		/**
		 * constructor
		 */
		public function StackItem(_url:String)
		{
			bmp.bitmapData = bmpData;
			addChild(bmp);
			
			reflectionBmp.bitmapData = reflectionBmpData;
			addChild(reflectionBmp);
			
			var urlRequest:URLRequest = new URLRequest(_url);
			
			imageLoader = new Loader();
			imageLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadComplete);
			imageLoader.load(urlRequest);			
			
			trace("StackItem* instantiated");
		}
		
		
		
		/**
		 * sorts the image data
		 */
		private function loadComplete(e:*):void
		{
			bmpData.draw(imageLoader.content);
			
			reflectionBmp.y = imageLoader.content.height;

			var flipMatrix:Matrix = new Matrix();
			flipMatrix.rotate(Math.PI);
			flipMatrix.translate(0, imageLoader.content.height);
			flipMatrix.scale(-1, 1);
			
			reflectionBmpData.draw(imageLoader.content, flipMatrix);
			reflectionBmp.alpha = 0.7;
			
			var filtersArray:Array = new Array();
			var blur:BlurFilter = new BlurFilter(2, 2, 1);
			filtersArray.push(blur);
			reflectionBmp.filters = filtersArray;
			
			// draw reflection
			reflectionBmpData.lock();
			for (var i:int = 0; i < 270; i++)
			{
				var rowFactor:Number = Math.max(0, 0.4 - (i / 270));
				for (var j:int = 0; j < 380; j++)
				{
					var pixelColor:uint = reflectionBmpData.getPixel32(j, i);
					var pixelAlpha:uint = pixelColor >>> 24;
					var pixelRGB:uint = pixelColor & 0xffffff;
					var resultAlpha:uint = pixelAlpha * rowFactor;
					reflectionBmpData.setPixel32(j, i, resultAlpha << 24 | pixelRGB);
				}
			}
			reflectionBmpData.unlock();
			
			imageLoader = null;
		}
	}
}
